/* tslint:disable */
/* eslint-disable */
/**
* No error reporting included.
* To get the detailed error code, use [`stream::BrotliDecStream`].
* @param {Uint8Array} input
* @returns {Uint8Array}
*/
export function brotli_dec(input: Uint8Array): Uint8Array;
/**
* See [`brotli_dec`].
*
* For drop-in replacement of `brotli-wasm`.
* @param {Uint8Array} buf
* @returns {Uint8Array}
*/
export function decompress(buf: Uint8Array): Uint8Array;
/**
* Same as [`brotli_decompressor::BrotliResult`] except [`brotli_decompressor::BrotliResult::ResultFailure`].
*
* Always `> 0`.
*
* `ResultFailure` is removed
* because we will convert the failure to an actual negative error code (if available) and pass it elsewhere.
*/
export enum BrotliStreamResultCode {
  ResultSuccess = 1,
  NeedsMoreInput = 2,
  NeedsMoreOutput = 3,
}
/**
* Copied and modified from enum BrotliDecoderErrorCode of dropbox/rust-brotli-decompressor.
* It is not PascalCase but kept in MACRO_CASE because changing all names is too troublesome.
* And most of the time you may not need to care about the error code.
* NOTICE: All numbers are reversed to positive, required by wasm_bindgen.
*/
export enum BrotliDecStreamErrCode {
  BROTLI_DECODER_ERROR_FORMAT_EXUBERANT_NIBBLE = 1,
  BROTLI_DECODER_ERROR_FORMAT_RESERVED = 2,
  BROTLI_DECODER_ERROR_FORMAT_EXUBERANT_META_NIBBLE = 3,
  BROTLI_DECODER_ERROR_FORMAT_SIMPLE_HUFFMAN_ALPHABET = 4,
  BROTLI_DECODER_ERROR_FORMAT_SIMPLE_HUFFMAN_SAME = 5,
  BROTLI_DECODER_ERROR_FORMAT_CL_SPACE = 6,
  BROTLI_DECODER_ERROR_FORMAT_HUFFMAN_SPACE = 7,
  BROTLI_DECODER_ERROR_FORMAT_CONTEXT_MAP_REPEAT = 8,
  BROTLI_DECODER_ERROR_FORMAT_BLOCK_LENGTH_1 = 9,
  BROTLI_DECODER_ERROR_FORMAT_BLOCK_LENGTH_2 = 10,
  BROTLI_DECODER_ERROR_FORMAT_TRANSFORM = 11,
  BROTLI_DECODER_ERROR_FORMAT_DICTIONARY = 12,
  BROTLI_DECODER_ERROR_FORMAT_WINDOW_BITS = 13,
  BROTLI_DECODER_ERROR_FORMAT_PADDING_1 = 14,
  BROTLI_DECODER_ERROR_FORMAT_PADDING_2 = 15,
  BROTLI_DECODER_ERROR_FORMAT_DISTANCE = 16,
  BROTLI_DECODER_ERROR_DICTIONARY_NOT_SET = 19,
  BROTLI_DECODER_ERROR_INVALID_ARGUMENTS = 20,
  BROTLI_DECODER_ERROR_ALLOC_CONTEXT_MODES = 21,
  BROTLI_DECODER_ERROR_ALLOC_TREE_GROUPS = 22,
  BROTLI_DECODER_ERROR_ALLOC_CONTEXT_MAP = 25,
  BROTLI_DECODER_ERROR_ALLOC_RING_BUFFER_1 = 26,
  BROTLI_DECODER_ERROR_ALLOC_RING_BUFFER_2 = 27,
  BROTLI_DECODER_ERROR_ALLOC_BLOCK_TYPE_TREES = 30,
  BROTLI_DECODER_ERROR_UNREACHABLE = 31,
}
/**
*/
export class BrotliDecStream {
  free(): void;
/**
*/
  constructor();
/**
* @param {Uint8Array} input
* @param {number} output_size
* @returns {BrotliStreamResult}
*/
  dec(input: Uint8Array, output_size: number): BrotliStreamResult;
/**
* See [`Self::dec()`].
*
* For drop-in replacement of `brotli-wasm`.
* @param {Uint8Array} input
* @param {number} output_size
* @returns {BrotliStreamResult}
*/
  decompress(input: Uint8Array, output_size: number): BrotliStreamResult;
/**
* @returns {number}
*/
  total_out(): number;
}
/**
* Returned by every successful (de)compression.
*/
export class BrotliStreamResult {
  free(): void;
/**
* Output buffer
*/
  buf: Uint8Array;
/**
* Result code.
*
* See [`BrotliStreamResultCode`] for available values.
*
* When error, the error code is not passed here but rather goes to `Err`.
*/
  code: number;
/**
* Consumed bytes of the input buffer
*/
  input_offset: number;
}

export type InitInput = RequestInfo | URL | Response | BufferSource | WebAssembly.Module;

export interface InitOutput {
  readonly memory: WebAssembly.Memory;
  readonly __wbg_brotlistreamresult_free: (a: number) => void;
  readonly __wbg_get_brotlistreamresult_code: (a: number) => number;
  readonly __wbg_set_brotlistreamresult_code: (a: number, b: number) => void;
  readonly __wbg_get_brotlistreamresult_buf: (a: number, b: number) => void;
  readonly __wbg_set_brotlistreamresult_buf: (a: number, b: number, c: number) => void;
  readonly __wbg_get_brotlistreamresult_input_offset: (a: number) => number;
  readonly __wbg_set_brotlistreamresult_input_offset: (a: number, b: number) => void;
  readonly __wbg_brotlidecstream_free: (a: number) => void;
  readonly brotlidecstream_new: () => number;
  readonly brotlidecstream_dec: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly brotlidecstream_total_out: (a: number) => number;
  readonly brotlidecstream_decompress: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly brotli_dec: (a: number, b: number, c: number) => void;
  readonly decompress: (a: number, b: number, c: number) => void;
  readonly BrotliDecoderCreateInstance: (a: number, b: number, c: number) => number;
  readonly BrotliDecoderSetParameter: (a: number, b: number, c: number) => void;
  readonly BrotliDecoderDecompressPrealloc: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number) => void;
  readonly BrotliDecoderDecompressWithReturnInfo: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly BrotliDecoderDecompress: (a: number, b: number, c: number, d: number) => number;
  readonly BrotliDecoderDecompressStream: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly BrotliDecoderDecompressStreaming: (a: number, b: number, c: number, d: number, e: number) => number;
  readonly BrotliDecoderMallocU8: (a: number, b: number) => number;
  readonly BrotliDecoderFreeU8: (a: number, b: number, c: number) => void;
  readonly BrotliDecoderMallocUsize: (a: number, b: number) => number;
  readonly BrotliDecoderFreeUsize: (a: number, b: number, c: number) => void;
  readonly BrotliDecoderDestroyInstance: (a: number) => void;
  readonly BrotliDecoderHasMoreOutput: (a: number) => number;
  readonly BrotliDecoderTakeOutput: (a: number, b: number) => number;
  readonly BrotliDecoderIsUsed: (a: number) => number;
  readonly BrotliDecoderIsFinished: (a: number) => number;
  readonly BrotliDecoderGetErrorCode: (a: number) => number;
  readonly BrotliDecoderGetErrorString: (a: number) => number;
  readonly BrotliDecoderErrorString: (a: number) => number;
  readonly BrotliDecoderVersion: () => number;
  readonly __wbindgen_add_to_stack_pointer: (a: number) => number;
  readonly __wbindgen_free: (a: number, b: number, c: number) => void;
  readonly __wbindgen_malloc: (a: number, b: number) => number;
  readonly __wbindgen_realloc: (a: number, b: number, c: number, d: number) => number;
}

export type SyncInitInput = BufferSource | WebAssembly.Module;
/**
* Instantiates the given `module`, which can either be bytes or
* a precompiled `WebAssembly.Module`.
*
* @param {SyncInitInput} module
*
* @returns {InitOutput}
*/
export function initSync(module: SyncInitInput): InitOutput;

/**
* If `module_or_path` is {RequestInfo} or {URL}, makes a request and
* for everything else, calls `WebAssembly.instantiate` directly.
*
* @param {InitInput | Promise<InitInput>} module_or_path
*
* @returns {Promise<InitOutput>}
*/
export default function __wbg_init (module_or_path?: InitInput | Promise<InitInput>): Promise<InitOutput>;
